import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:imi/src/utils/enum.dart';

///
/// Code generated by jsonToDartModel https://ashamp.github.io/jsonToDartModel/
///
class MissionOfDay {
/*
{
  "id": 8,
  "name": "Nhiệm vụ thiền",
  "type": "MEDITATION"
}
*/

  int? id;
  String? name;
  MissionType? type;

  MissionOfDay({
    this.id,
    this.name,
    this.type,
  });
  MissionOfDay.fromJson(Map<String, dynamic> json) {
    id = json['id']?.toInt();
    name = json['name']?.toString();
    type = MissionType.values
        .firstWhereOrNull((element) => element.name == json['type']);
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data['id'] = id;
    data['name'] = name;
    data['type'] = type?.name;
    return data;
  }
}

class FetchMissionOfDay {
/*
{
  "completed": false,
  "completedDate": null,
  "id": 290,
  "mission": {
    "id": 8,
    "name": "Nhiệm vụ thiền",
    "type": "MEDITATION"
  }
}
*/

  bool? completed;
  DateTime? completedDate;
  int? id;
  MissionOfDay? mission;

  FetchMissionOfDay({
    this.completed,
    this.completedDate,
    this.id,
    this.mission,
  });
  FetchMissionOfDay.fromJson(Map<String, dynamic> json) {
    completed = json['completed'];
    if (json['completedDate'] != null)
      completedDate =
          DateTime.fromMillisecondsSinceEpoch(json['completedDate']?.toInt());
    id = json['id']?.toInt();
    mission = (json['mission'] != null)
        ? MissionOfDay.fromJson(json['mission'])
        : null;
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data['completed'] = completed;
    data['completedDate'] = completedDate;
    data['id'] = id;
    if (mission != null) {
      data['mission'] = mission!.toJson();
    }
    return data;
  }
}

class MissionData {
/*
{
  "missions": [
    {
      "completed": false,
      "completedDate": null,
      "id": 290,
      "mission": {
        "id": 8,
        "name": "Nhiệm vụ thiền",
        "type": "MEDITATION"
      }
    }
  ],
  "note": null
}
*/

  List<FetchMissionOfDay>? missions;
  String? note;

  MissionData({
    this.missions,
    this.note,
  });
  MissionData.fromJson(Map<String, dynamic> json) {
    if (json['missions'] != null) {
      final v = json['missions'];
      final arr0 = <FetchMissionOfDay>[];
      v.forEach((v) {
        arr0.add(FetchMissionOfDay.fromJson(v));
      });
      missions = arr0;
    }
    note = json['note']?.toString();
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    if (missions != null) {
      final v = missions;
      final arr0 = [];
      v!.forEach((v) {
        arr0.add(v.toJson());
      });
      data['missions'] = arr0;
    }
    data['note'] = note;
    return data;
  }
}

class MissionResponse {
/*
{
  "fetchMissionOfDay": {
    "missions": [
      {
        "completed": false,
        "completedDate": null,
        "id": 290,
        "mission": {
          "id": 8,
          "name": "Nhiệm vụ thiền",
          "type": "MEDITATION"
        }
      }
    ],
    "note": null
  }
}
*/

  MissionData? fetchMissionOfDay;

  MissionResponse({
    this.fetchMissionOfDay,
  });
  MissionResponse.fromJson(Map<String, dynamic> json) {
    fetchMissionOfDay = (json['fetchMissionOfDay'] != null)
        ? MissionData.fromJson(json['fetchMissionOfDay'])
        : null;
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    if (fetchMissionOfDay != null) {
      data['fetchMissionOfDay'] = fetchMissionOfDay!.toJson();
    }
    return data;
  }
}

class Mission {
/*
{
  "data": {
    "fetchMissionOfDay": {
      "missions": [
        {
          "completed": false,
          "completedDate": null,
          "id": 290,
          "mission": {
            "id": 8,
            "name": "Nhiệm vụ thiền",
            "type": "MEDITATION"
          }
        }
      ],
      "note": null
    }
  }
}
*/

  MissionResponse? data;

  Mission({
    this.data,
  });
  Mission.fromJson(Map<String, dynamic> json) {
    data =
        (json['data'] != null) ? MissionResponse.fromJson(json['data']) : null;
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    if (data != null) {
      data['data'] = this.data!.toJson();
    }
    return data;
  }
}
